import { LanguageServerPlugin, RuntimeEnvironment } from '../types';
import * as embedded from '@volar/language-service';
import { URI } from 'vscode-uri';
import type * as _ from 'vscode-languageserver-textdocument';
export declare function createDocumentServiceHost(runtimeEnv: RuntimeEnvironment, plugins: ReturnType<LanguageServerPlugin>[], ts: typeof import('typescript/lib/tsserverlibrary'), configHost: embedded.ConfigurationHost | undefined): {
    add: (rootUri: URI) => void;
    remove: (rootUri: URI) => void;
    get: (documentUri: string) => {
        format: (document: _.TextDocument, options: import("vscode-languageserver").FormattingOptions, range?: import("vscode-languageserver").Range | undefined, onTypeParams?: {
            ch: string;
            position: import("vscode-languageserver").Position;
        } | undefined) => Promise<import("vscode-languageserver").TextEdit[] | undefined>;
        getFoldingRanges: (document: _.TextDocument) => Promise<import("vscode-languageserver").FoldingRange[] | undefined>;
        getSelectionRanges: (document: _.TextDocument, positions: import("vscode-languageserver").Position[]) => Promise<import("vscode-languageserver").SelectionRange[] | undefined>;
        findLinkedEditingRanges: (document: _.TextDocument, position: import("vscode-languageserver").Position) => Promise<import("vscode-languageserver").LinkedEditingRanges | undefined>;
        findDocumentSymbols: (document: _.TextDocument) => Promise<import("vscode-languageserver").SymbolInformation[] | undefined>;
        findDocumentColors: (document: _.TextDocument) => Promise<import("vscode-languageserver").ColorInformation[] | undefined>;
        getColorPresentations: (document: _.TextDocument, color: import("vscode-languageserver").Color, range: import("vscode-languageserver").Range) => Promise<import("vscode-languageserver").ColorPresentation[] | undefined>;
        doAutoInsert: (document: _.TextDocument, position: import("vscode-languageserver").Position, options: {
            lastChange: {
                range: import("vscode-languageserver").Range;
                rangeOffset: number;
                rangeLength: number;
                text: string;
            };
        }) => Promise<NonNullable<string | import("vscode-languageserver").TextEdit | null | undefined> | undefined>;
        context: embedded.DocumentServiceRuntimeContext;
    };
};
